#include <iostream>

using namespace std;

long int f(long int x[],long int k,long int koliko){
   long int zarada=0;
    if(k==0){
        for(int i=0;i<koliko;i++){
            zarada=zarada+x[i];
        }
    }else{
		k=k-1;
		for(long int i =0 ; i < koliko; i++){

            for (long int j = i; j < koliko; j++){
            	long int pom[j];
            	long int st=0;
                for (long int l = i; l <= j; l++){
                	
                	pom[st]=x[l];
                	st++;
            	}
            	zarada=zarada+f(pom,k,st);
            	
            }

        }
    }
	return zarada;

}
int main(int argc, char** argv) {
	long int n;
	long int k;
	cin>>n>>k;
	long int niz[n];
	for(int i=0;i<n;i++){
		cin>>niz[i];
	}
	long int res=f(niz,k,n);
	while (res>1000000007){
		res=res-1000000007;
	}
	cout<<res;
	return 0;
}